;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-reader.ss" "lang")((modname Hausi8_Vorlage) (read-case-sensitive #t) (teachpacks ((lib "universe.rkt" "teachpack" "2htdp") (lib "image.rkt" "teachpack" "2htdp"))) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ((lib "universe.rkt" "teachpack" "2htdp") (lib "image.rkt" "teachpack" "2htdp")) #f)))

; Aufgabe 1 - Programmieren mit Listen
; ------------------------------------

; Example Lists
(define LIST-1 (list 12 5 1 34 8))
(define LIST-2 empty)
(define LIST-3 (list 4))
(define LIST-04 (list 1 9 0 4))
(define LIST-5 (list 2 -3 4 -8))
(define LIST-6 (list 2 4 6 8 10))
(define LIST-7 (list 1 3 3 5 7))
(define LIST-8 (list 2 4 6 8))
(define LIST-9 (list 1 3 5 7 7))

; product
;
; List-Of-Numbers -> Number
; multiplies all numbers contained in the given list, returns 1 if the list is empty.
(check-expect (product LIST-1) 16320)
(check-expect (product LIST-2) 1)
(check-expect (product LIST-3) 4)
(check-expect (product LIST-04) 0)
(define (product lst)
  (cond
    [(empty? lst) 1]
    [(cons? lst) (* (first lst) (product (rest lst)))]))

; all-positive?
;
; List-Of-Numbers -> Boolean
; returns whether all numbers in the list are positive.
(check-expect (all-positive? LIST-1) #true)
(check-expect (all-positive? LIST-2) #true)
(check-expect (all-positive? LIST-3) #true)
(check-expect (all-positive? LIST-5) #false)
(define (all-positive? lst)
  (cond
    [(empty? lst) #true]             
    [(cons? lst) (if (> (first lst) 0)
                     (all-positive? (rest lst))
                     #false)]))

; all-greater-than?
;
; Number List-Of-Numbers -> Boolean
; determines whether all elements in a list are greater than or equal a given number.
(check-expect (all-greater-than? 10 LIST-1) #false)
(check-expect (all-greater-than? 0 LIST-2) #true)
(check-expect (all-greater-than? 1 LIST-04) #false)
(check-expect (all-greater-than? 6 LIST-3) #false)
(define (all-greater-than? num lst)
  (cond
    [(empty? lst) #true]
    [(cons? lst) (and (>= (first lst) num)
                      (all-greater-than? num (rest lst)))]))

; sorted?
;
; List-Of-Numbers -> Boolean
; determines whether a given list of numbers is sorted in ascending order.
(check-expect (sorted? LIST-1) #false)
(check-expect (sorted? LIST-2) #true)
(check-expect (sorted? LIST-3) #true)
(check-expect (sorted? LIST-04) #false)
(check-expect (sorted? LIST-6) #true)
(check-expect (sorted? LIST-7) #true)
(define (sorted? lst)
  (cond
    [(or (empty? lst) (empty? (rest lst))) #true]
    [(and (cons? lst) (cons? (rest lst))) (and (<= (first lst) (first (rest lst)))
                                               (sorted? (rest lst)))]))

;; number-of-elements (Hilfsfunktion, die ich dann doch nicht verwendet habe)
;;
;; List -> number
;; determines the number of elements of a given list 
;(check-expect (number-of-elements LIST-1) 5)
;(check-expect (number-of-elements LIST-2) 0)
;(check-expect (number-of-elements LIST-3) 1)
;(define (number-of-elements lst)
;  (cond
;    [(empty? lst) 0]
;    [(cons? lst) (+ 1 (number-of-elements (rest lst)))]))

; add-one/list
;
; List-Of-Numbers -> List-Of-Numbers
; returns a list with the same elements, but every element is incremented by 1.
(check-expect (add-one/list LIST-04) (list 2 10 1 5)) 
(check-expect (add-one/list LIST-2) empty) 
(check-expect (add-one/list LIST-3) (list 5)) 
(check-expect (add-one/list LIST-5) (list 3 -2 5 -7))
(define (add-one/list lst)
  (cond
    [(empty? lst) empty]
    [(cons? lst) (cons (add1 (first lst)) 
                       (add-one/list (rest lst)))]))

; list=?
;
; List-Of-Numbers List-Of-Numbers -> Boolean
; determines whether two lists contain the exactly same elements in the same order
(check-expect (list=? LIST-1 LIST-2) #false)
(check-expect (list=? LIST-1 LIST-04) #false)
(check-expect (list=? LIST-2 LIST-2) #true)
(check-expect (list=? LIST-6 LIST-6) #true)
(check-expect (list=? LIST-5 LIST-5) #true)
(check-expect (list=? LIST-04 LIST-6) #false)
(check-expect (list=? LIST-6 LIST-8) #false)
(check-expect (list=? LIST-8 LIST-6) #false)
(define (list=? lst1 lst2)
  (cond
    [(and (empty? lst1) (empty? lst2)) #true]
    [(or (empty? lst1) (empty? lst2)) #false]
    [(and (cons? lst1) (cons? lst2))
     (and (= (first lst1) (first lst2))
          (list=? (rest lst1) (rest lst2)))]))


; Aufgabe 2 - Listen als Mengen
; ----------------------------------------------

; subset?
;
; List-Of-Numbers List-Of-Numbers -> Boolean
; determines whether all elements in lst1 are also contained in lst2
(check-expect (subset? LIST-1 LIST-2) #false)
(check-expect (subset? LIST-2 LIST-1) #true)
(check-expect (subset? LIST-3 LIST-04) #true)
(check-expect (subset? LIST-8 LIST-6) #true)
(check-expect (subset? LIST-6 LIST-8) #false)
(define (subset? lst1 lst2)
  (cond
    [(empty? lst1) #true]
    [(empty? lst2) #false]
    [(and (cons? lst1) (cons? lst2))
     (if (number-in-list? lst2 (first lst1))
         (subset? (rest lst1) lst2)
         #false)]))

; set=?
;
; List-Of-Numbers List-Of-Numbers -> Boolean
; determines whether lst1 and lst2 contain the same elements
(check-expect (set=? LIST-1 LIST-2) #false)
(check-expect (set=? LIST-2 LIST-1) #false)
(check-expect (set=? LIST-2 LIST-2) #true)
(check-expect (set=? LIST-1 LIST-1) #true)
(check-expect (set=? LIST-6 LIST-8) #false)
(check-expect (set=? LIST-8 LIST-6) #false)
(check-expect (set=? LIST-7 LIST-9) #true)                      
(define (set=? lst1 lst2)
  (cond
    [(and (empty? lst1) (empty? lst2)) #true]
    [(or (cons? lst1) (cons? lst2)) (and (subset? lst1 lst2)
                                         (subset? lst2 lst1))]))

; difference
;
; List-Of-Numbers List-Of-Numbers -> List-Of-Numbers
; returns a set, containing the elements that occur in lst1, but not in lst2
(check-expect (difference LIST-1 LIST-2) LIST-1)
(check-expect (difference LIST-2 LIST-1) empty)
(check-expect (difference LIST-3 LIST-04) empty)
(check-expect (difference LIST-04 LIST-3) (list 1 9 0))
(check-expect (difference LIST-6 LIST-8) (list 10))
(check-expect (difference LIST-8 LIST-6) empty)
(define (difference lst1 lst2)
  (cond
    [(empty? lst1) empty]
    [(empty? lst2) lst1]
    [(and (cons? lst1) (cons? lst2))
     (if (number-in-list? lst2 (first lst1))
         (difference (rest lst1) lst2)
         (cons (first lst1) (difference (rest lst1) lst2)))]))

; number-in-list?
;
; List-Of-Number number -> Boolean
; checks, if a number is part of a given list
(check-expect (number-in-list? LIST-1 5) #true)
(check-expect (number-in-list? LIST-2 7) #false)
(check-expect (number-in-list? LIST-04 4) #true)
(define (number-in-list? lst num)
  (cond
    [(empty? lst) #false]
    [(cons? lst) (or (= (first lst) num)
                     (number-in-list? (rest lst) num))]))

; Aufgabe 3 - Programmieren mit Bäumen
; ------------------------------------
; Gegeben wieder die Definition von Bäumen aus dem Tutorium:

(define-struct node (left value right))
(define-struct empty-tree ())
; An EmptyTree is a structure (make-empty-tree))
; interp. an empty tree
(define EMPTY (make-empty-tree))
; A Tree-Of-Numbers is one of:
; - (make-node Tree-Of-Numbers Number Tree-Of-Numbers)
; - EmptyTree
; interp. a tree with numbers stored at its nodes.

; Example 1.
;            6
;           / \
;         42   3
;         /   / \
;        8   15  2
(define EX-TREE
  (make-node (make-node (make-node EMPTY 8 EMPTY)
                        42
                        EMPTY)
             6
             (make-node (make-node EMPTY 15 EMPTY)
                        3
                        (make-node EMPTY 2 EMPTY))))

(define EX-TREE-2
  (make-node (make-node 
              (make-node (make-node EMPTY 8 EMPTY) 7 EMPTY) 
              0 
              (make-node (make-node EMPTY 0 EMPTY) 3 (make-node (make-node EMPTY 1 EMPTY) 2 EMPTY)))
             5
             (make-node EMPTY 2 EMPTY)))

; sum/tree
;
; Tree-Of-Numbers -> Number
; sums all numbers in a tree of numbers.
(check-expect (sum/tree EX-TREE) 76)
(check-expect (sum/tree EMPTY) 0)
(check-expect (sum/tree EX-TREE-2) 28)
(define (sum/tree tree)
  (cond
    [(empty-tree? tree) 0]
    [(node? tree) (+
                   (node-value tree)
                   (sum/tree (node-left tree))
                   (sum/tree (node-right tree)))]))

; mul/tree
;
; Tree-Of-Numbers -> Number
; multiplies all numbers in a tree of numbers.
(check-expect (mul/tree EMPTY) 1)
(check-expect (mul/tree EX-TREE) 181440)
(check-expect (mul/tree EX-TREE-2) 0)
(define (mul/tree tree)
  (cond 
    [(empty-tree? tree) 1]
    [(node? tree)  (*
                    (node-value tree)
                    (mul/tree (node-left tree))
                    (mul/tree (node-right tree)))]))

; add-one/tree
;
; Tree-Of-Numbers -> Tree-Of-Numbers
; returns the same tree, but with 1 added to every element
(check-expect (add-one/tree EMPTY) EMPTY)
(check-expect (add-one/tree EX-TREE) (make-node (make-node (make-node EMPTY 9 EMPTY)
                                                           43
                                                           EMPTY)
                                                7
                                                (make-node (make-node EMPTY 16 EMPTY)
                                                           4
                                                           (make-node EMPTY 3 EMPTY))))
(check-expect (add-one/tree EX-TREE-2) (make-node (make-node 
                                                   (make-node (make-node EMPTY 9 EMPTY) 8 EMPTY) 
                                                   1 
                                                   (make-node (make-node EMPTY 1 EMPTY) 4 (make-node (make-node EMPTY 2 EMPTY) 3 EMPTY)))
                                                  6
                                                  (make-node EMPTY 3 EMPTY)))
(define (add-one/tree tree)
  (cond [(empty-tree? tree) EMPTY]
        [(node? tree) (make-node (add-one/tree (node-left tree))
                                 (add1 (node-value tree))
                                 (add-one/tree (node-right tree)))]))


; Aufgabe 4: Arithmetische Ausdrücke auswerten
; --------------------------------------------
(define-struct literal (value))
(define-struct addition (lhs rhs))
(define-struct subtraction (lhs rhs))
(define-struct multiplication (lhs rhs))
(define-struct division (lhs rhs))
; An Expression is one of:
; - (make-literal Number)
; - (make-addition Expression Expression)
; - (make-subtraction Expression Expression)
; - (make-multiplication Expression Expression)
; - (make-division Expression Expression)
; interp. abstract syntax tree of arithmetic expressions
(define EXPRESSION-1 (make-literal 1904))
(define EXPRESSION-2 (make-addition (make-literal 19) (make-literal 4)))
(define EXPRESSION-3 (make-subtraction (make-literal 0) (make-literal 89)))
(define EXPRESSION-4 (make-multiplication (make-literal 8) (make-literal 9)))
(define EXPRESSION-5 (make-division (make-literal 4) (make-literal 2)))
(define EXPRESSION-5a (make-multiplication 
                       (make-addition (make-literal 3) (make-literal 5)) 
                       (make-literal 2)))
(define EXPRESSION-6 (make-division (make-addition (make-multiplication (make-literal 11) 
                                                                        (make-division (make-literal 90) 
                                                                                       (make-literal 10)))
                                                   (make-addition (make-literal 6) 
                                                                  (make-literal 10)))
                                    (make-subtraction (make-literal 7) 
                                                      (make-addition (make-multiplication (make-literal 7)
                                                                                          (make-literal 0)) 
                                                                     (make-division (make-literal 8) 
                                                                                    (make-literal 4))))))
(define EXPRESSION-7 (make-division 17 0))
(define EXPRESSION-8 (make-addition (make-multiplication (make-literal 3) 
                                                         (make-literal 4)) 
                                    (make-division (make-literal 1904) 
                                                   (make-subtraction (make-literal 8) 
                                                                     (make-literal 8)))))
; evaluate
;
; Expression -> Number
; computes the numeric value of an arithmetic expression
(check-expect (evaluate EXPRESSION-1) 1904)
(check-expect (evaluate EXPRESSION-2) 23)
(check-expect (evaluate EXPRESSION-3) -89)
(check-expect (evaluate EXPRESSION-4) 72)
(check-expect (evaluate EXPRESSION-5) 2)
(check-expect (evaluate EXPRESSION-5a) 16)
(check-expect (evaluate EXPRESSION-6) 23)
;(check-expect (evaluate EXPRESSION-7) (error "You divided by zero you stupid fool! Please try again!"))
;(check-expect (evaluate EXPRESSION-8) (error "You divided by zero you stupid fool! Please try again!"))
(define (evaluate expr)
  (cond
    [(literal? expr) (literal-value expr) ]
    [(addition? expr) (+ (evaluate (addition-lhs expr))
                         (evaluate (addition-rhs expr)))]
    [(subtraction? expr) (- (evaluate (subtraction-lhs expr))
                            (evaluate (subtraction-rhs expr)))]
    [(multiplication? expr) (* (evaluate (multiplication-lhs expr))
                               (evaluate (multiplication-rhs expr)))]
    [(division? expr) (if (= (evaluate (division-rhs expr)) 0)
                          (error "You divided by zero you stupid fool! Please try again!")
                          (/ (evaluate (division-lhs expr))
                             (evaluate (division-rhs expr))))]))
; Die Fehlermeldung konnte ich nicht testen, da sonst bei jedem Run des Programms ein Fehler auftrat.
; Ich habe dann im Forum nachgefragt und es hieß, dass ich die Testfälle für die Fehlermeldung weglassen soll

;    [(division? expr) (/ (evaluate (division-lhs expr))
;                         (evaluate (division-rhs expr)))]))    